#include <SoftwareSerial.h> 
#define BT_rxPin 3 // Bluetooth RX -> 3(arduino TX)
#define BT_txPin 2 // Bluetooth TX -> 2(arduino RX)
SoftwareSerial btSerial(BT_txPin, BT_rxPin); // (arduino RX, arduino TX)

String s =""; // 시리얼 모니터 텍스트 제어용 변수

// 블루투스 앱 디지털 핀 제어용 변수
bool get_pin_val = false;
uint8_t pin_count = 0;
uint8_t pin_a[3] = {0, };
uint8_t pin_val;

// 블루투스 앱 PWM 제어용 변수
bool get_pwm_val = false;
uint8_t pwm_count = 0;
uint8_t pwm_a[5] = {0, };
uint16_t pwm1 = 0;  
uint16_t pwm2 = 0;  
uint16_t pwm3 = 0;  

// 블루투스 앱 상태표시 변수
uint8_t pin_echo[] = {0xF0, 0, 0xF1};
uint8_t pwm_echo[] = {0xF3, 0, 0, 0, 0xF1};
uint8_t pwm_slide[] = {0xF4, 0, 0, 0, 0xF1};

void setup() {
  Serial.begin(9600);
  btSerial.begin(9600); //Bluetooth 
}

void loop() {
  btSerial_read(); // 블루투스 시리얼 읽기 함수
  if(Serial.available()) { // 시리얼 버퍼에 데이터 있으면
    char c = Serial.read();  
    if(c != '\n') {
      s += c;
    } else {
      if(s == "on"){ // 시리얼 모니터 제어 led on
        Serial.println("LED ON");
        send_pin_echo(11); // 블루투스 앱 버튼 상태: on
        btSerial.print("LED ON");
        s = "";  
      }
      else if(s == "off"){ // 시리얼 모니터 제어 led off 
        Serial.println("LED OFF"); 
        send_pin_echo(10); // 블루투스 앱 버튼 상태: off
        btSerial.print("LED OFF");  
        s = "";
      }
      else {
        btSerial.println(s); 
        s = "";
      }
    }
  }
}

void general_use() { 
  char text = btSerial.read();  // text value for some purpose.
  Serial.write(text);      // print text to Serial Monitor
}

void pin_control() {
  pin_val = pin_a[1];
  if (pin_val != 0) {
    switch (pin_val) {
      case 11: Serial.println("button 1 : on"); 
                  break;
      case 10: Serial.println("button 1 : off");
                  break;
      case 21: Serial.println("button 2 : on");
               send_pin_echo(pin_val); // 버튼 상태 echo 
                  break;
      case 20: Serial.println("button 2 : off");
               send_pin_echo(pin_val); // 버튼 상태 echo 
                  break;
      case 31: Serial.println("button 3 : on");
                  break;
      case 30: Serial.println("button 3 : off");
                  break;
      case 41: Serial.println("button 4 : on");
                  break;
      case 40: Serial.println("button 4 : off");
                  break;
      case 51: Serial.println("button 5 : on");
                  break;
      case 50: Serial.println("button 5 : off");
                  break;
      case 61: Serial.println("button 6 : on");
                  break;
      case 60: Serial.println("button 6 : off");
                  break;
      case 71: Serial.println("button 7 : on");
                  break;
      case 70: Serial.println("button 7 : off");
                  break;
      case 81: Serial.println("button 8 : on");
                  break;
      case 80: Serial.println("button 8 : off");
                  break;
      case 91: Serial.println("button 9 : on");
                  break;
      case 90: Serial.println("button 9 : off");
                  break;  
      case 101: Serial.println("button 10 : on");
                  break;
      case 100: Serial.println("button 10 : off");
                  break;  
      case 111: Serial.println("button 11 : on");
                  break;
      case 110: Serial.println("button 11 : off");
                  break;  
      case 121: Serial.println("button 12 : on");
                  break;
      case 120: Serial.println("button 12 : off");
                  break;  
    }
  pin_val = 0;
  }
}

void pwm_control() {
  uint16_t temp = pwm_a[3];
  temp = temp << 8 | pwm_a[2];
  if (pwm_a[1] == 1) {  // 슬라이드 1번
    pwm1 = temp;
//    send_pwm_echo(1, pwm1); // PWM 값 echo
    Serial.print("pwm1: "); Serial.println(pwm1);
  }
  else if (pwm_a[1] == 2) { // 슬라이드 2번
    pwm2 = temp;
    Serial.print("pwm2: "); Serial.println(pwm2);
  }
  else if (pwm_a[1] == 3) {  // 슬라이드 3번
    pwm3 = temp;
    Serial.print("pwm3: "); Serial.println(pwm3);
  }
}

void btSerial_read() {
  if (btSerial.available()) {  
    if (btSerial.peek() == 0xF3) get_pwm_val = true; 
    else if (btSerial.peek() == 0xF0) get_pin_val = true; 
    if (get_pwm_val == true ) { // pwm 제어값 수신
      uint8_t temp = btSerial.read();
      pwm_a[pwm_count] = temp;
      pwm_count++; 
      if (temp == 0xF1) {
        get_pwm_val = false;
        pwm_count = 0;
        pwm_control();
      }
    }
    else if (get_pin_val == true) {  // 디지털 핀 제어값 수신
      uint8_t temp = btSerial.read();
      pin_a[pin_count] = temp;
      pin_count++;
      if (temp == 0xF1) {
        get_pin_val = false;
        pin_count = 0;
        pin_control();
      }
    }
    else {
      if (btSerial.peek() == 0xF8) {
        String temp = btSerial.readStringUntil('\n');
        Serial.println(temp);
      }
      else if (btSerial.peek() == 0xF9) {
        String temp = btSerial.readStringUntil('\n');
        Serial.println(temp);
      } 
      else {
        general_use();  // 텍스트 출력함수
      }
    }
  }
}

void send_pin_echo(uint8_t pin_val){
  pin_echo[1] = pin_val;
  for (int i = 0; i < 3; i++) {
    btSerial.write(pin_echo[i]);
  }
}

void send_pwm_echo(uint8_t slide, uint16_t pwm_val) {
  pwm_echo[1] = slide;
  if (pwm_val < 256) {
    pwm_echo[2] = pwm_val;
    pwm_echo[3] = 0;
  }
  else {
    pwm_echo[2] = pwm_val;
    pwm_echo[3] = pwm_val >> 8;
  }
  for (int i = 0; i < 5; i++) {
    btSerial.write(pwm_echo[i]);
  }
}

void send_pwm_slide(uint8_t slide, uint16_t pwm_val) {
  pwm_slide[1] = slide;
  if (pwm_val < 256) {
    pwm_slide[2] = pwm_val;
    pwm_slide[3] = 0;
  }
  else {
    pwm_slide[2] = pwm_val;
    pwm_slide[3] = pwm_val >> 8;
  }
  for (int i = 0; i < 5; i++) {
    btSerial.write(pwm_slide[i]);
  }
}
